blob: 414e4df9f526b0cd21038c7b7ee7a8ac69e0a53e [file] [log] [blame]
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +01001#!/bin/bash
2#
3# Runner for an individual run-test.
4
5msg() {
6 if [ "$QUIET" = "n" ]; then
7 echo "$@"
8 fi
9}
10
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000011ANDROID_ROOT="/system"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010012ARCHITECTURES_32="(arm|x86|mips|none)"
Andreas Gampe1a5c4062015-01-15 12:10:47 -080013ARCHITECTURES_64="(arm64|x86_64|mips64|none)"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010014ARCHITECTURES_PATTERN="${ARCHITECTURES_32}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000015BOOT_IMAGE=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010016COMPILE_FLAGS=""
17DALVIKVM="dalvikvm32"
18DEBUGGER="n"
19DEV_MODE="n"
20DEX2OAT=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010021FALSE_BIN="/system/bin/false"
22FLAGS=""
23GDB=""
Nicolas Geoffraybaf91022014-10-08 09:56:45 +010024GDB_ARGS=""
25GDB_SERVER="gdbserver"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010026HAVE_IMAGE="y"
27HOST="n"
28INTERPRETER="n"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -080029JIT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010030INVOKE_WITH=""
31ISA=x86
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000032LIBRARY_DIRECTORY="lib"
33MAIN=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010034OPTIMIZE="y"
35PATCHOAT=""
36PREBUILD="y"
37QUIET="n"
38RELOCATE="y"
Jeff Hao207a37d2014-10-29 17:24:25 -070039SECONDARY_DEX=""
Brian Carlstrom93d6ce52014-11-04 22:31:35 -080040TIME_OUT="y"
Andreas Gampe038bb222015-01-13 19:48:14 -080041# Value in minutes.
Mathieu Chartier8dcde232015-01-15 17:23:16 -080042TIME_OUT_VALUE=10
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010043USE_GDB="n"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +010044USE_JVM="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045VERIFY="y"
46ZYGOTE=""
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -070047DEX_VERIFY=""
Andreas Gampe65357032015-02-19 15:10:24 -080048USE_DEX2OAT_AND_PATCHOAT="y"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010049
50while true; do
51 if [ "x$1" = "x--quiet" ]; then
52 QUIET="y"
53 shift
54 elif [ "x$1" = "x--lib" ]; then
55 shift
56 if [ "x$1" = "x" ]; then
57 echo "$0 missing argument to --lib" 1>&2
58 exit 1
59 fi
60 LIB="$1"
61 shift
62 elif [ "x$1" = "x-Xcompiler-option" ]; then
63 shift
64 option="$1"
65 FLAGS="${FLAGS} -Xcompiler-option $option"
66 COMPILE_FLAGS="${COMPILE_FLAGS} $option"
67 shift
68 elif [ "x$1" = "x--runtime-option" ]; then
69 shift
70 option="$1"
71 FLAGS="${FLAGS} $option"
72 shift
73 elif [ "x$1" = "x--boot" ]; then
74 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000075 BOOT_IMAGE="$1"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010076 shift
77 elif [ "x$1" = "x--no-dex2oat" ]; then
78 DEX2OAT="-Xcompiler:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -080079 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010080 shift
81 elif [ "x$1" = "x--no-patchoat" ]; then
82 PATCHOAT="-Xpatchoat:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -080083 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010084 shift
85 elif [ "x$1" = "x--relocate" ]; then
86 RELOCATE="y"
87 shift
88 elif [ "x$1" = "x--no-relocate" ]; then
89 RELOCATE="n"
90 shift
91 elif [ "x$1" = "x--prebuild" ]; then
92 PREBUILD="y"
93 shift
94 elif [ "x$1" = "x--host" ]; then
95 HOST="y"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +000096 ANDROID_ROOT="$ANDROID_HOST_OUT"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010097 shift
98 elif [ "x$1" = "x--no-prebuild" ]; then
99 PREBUILD="n"
100 shift
101 elif [ "x$1" = "x--no-image" ]; then
102 HAVE_IMAGE="n"
103 shift
Jeff Hao207a37d2014-10-29 17:24:25 -0700104 elif [ "x$1" = "x--secondary" ]; then
105 SECONDARY_DEX=":$DEX_LOCATION/$TEST_NAME-ex.jar"
106 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100107 elif [ "x$1" = "x--debug" ]; then
108 DEBUGGER="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800109 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100110 shift
111 elif [ "x$1" = "x--gdb" ]; then
112 USE_GDB="y"
113 DEV_MODE="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800114 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100115 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700116 elif [ "x$1" = "x--gdb-arg" ]; then
117 shift
118 gdb_arg="$1"
119 GDB_ARGS="${GDB_ARGS} $gdb_arg"
120 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100121 elif [ "x$1" = "x--zygote" ]; then
122 ZYGOTE="-Xzygote"
123 msg "Spawning from zygote"
124 shift
125 elif [ "x$1" = "x--dev" ]; then
126 DEV_MODE="y"
127 shift
128 elif [ "x$1" = "x--interpreter" ]; then
129 INTERPRETER="y"
130 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800131 elif [ "x$1" = "x--jit" ]; then
132 JIT="y"
133 shift
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100134 elif [ "x$1" = "x--jvm" ]; then
135 USE_JVM="y"
136 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100137 elif [ "x$1" = "x--invoke-with" ]; then
138 shift
139 if [ "x$1" = "x" ]; then
140 echo "$0 missing argument to --invoke-with" 1>&2
141 exit 1
142 fi
143 if [ "x$INVOKE_WITH" = "x" ]; then
144 INVOKE_WITH="$1"
145 else
146 INVOKE_WITH="$INVOKE_WITH $1"
147 fi
148 shift
149 elif [ "x$1" = "x--no-verify" ]; then
150 VERIFY="n"
151 shift
152 elif [ "x$1" = "x--no-optimize" ]; then
153 OPTIMIZE="n"
154 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000155 elif [ "x$1" = "x--android-root" ]; then
156 shift
157 ANDROID_ROOT="$1"
158 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100159 elif [ "x$1" = "x--" ]; then
160 shift
161 break
162 elif [ "x$1" = "x--64" ]; then
163 ISA="x86_64"
164 GDB_SERVER="gdbserver64"
165 DALVIKVM="dalvikvm64"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000166 LIBRARY_DIRECTORY="lib64"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100167 ARCHITECTURES_PATTERN="${ARCHITECTURES_64}"
168 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700169 elif [ "x$1" = "x--pic-test" ]; then
170 FLAGS="${FLAGS} -Xcompiler-option --compile-pic"
171 COMPILE_FLAGS="${COMPILE_FLAGS} --compile-pic"
172 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100173 elif expr "x$1" : "x--" >/dev/null 2>&1; then
174 echo "unknown $0 option: $1" 1>&2
175 exit 1
176 else
177 break
178 fi
179done
180
181if [ "x$1" = "x" ] ; then
182 MAIN="Main"
183else
184 MAIN="$1"
Andreas Gampef2fdc732014-06-11 08:20:47 -0700185 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100186fi
187
188if [ "$ZYGOTE" = "" ]; then
189 if [ "$OPTIMIZE" = "y" ]; then
190 if [ "$VERIFY" = "y" ]; then
191 DEX_OPTIMIZE="-Xdexopt:verified"
192 else
193 DEX_OPTIMIZE="-Xdexopt:all"
194 fi
195 msg "Performing optimizations"
196 else
197 DEX_OPTIMIZE="-Xdexopt:none"
198 msg "Skipping optimizations"
199 fi
200
201 if [ "$VERIFY" = "y" ]; then
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100202 JVM_VERIFY_ARG="-Xverify:all"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100203 msg "Performing verification"
204 else
205 DEX_VERIFY="-Xverify:none"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100206 JVM_VERIFY_ARG="-Xverify:none"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100207 msg "Skipping verification"
208 fi
209fi
210
211msg "------------------------------"
212
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100213if [ "$DEBUGGER" = "y" ]; then
214 # Use this instead for ddms and connect by running 'ddms':
215 # DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_android_adb,server=y,suspend=y"
216 # TODO: add a separate --ddms option?
217
218 PORT=12345
219 msg "Waiting for jdb to connect:"
220 if [ "$HOST" = "n" ]; then
221 msg " adb forward tcp:$PORT tcp:$PORT"
222 fi
223 msg " jdb -attach localhost:$PORT"
224 DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_socket,address=$PORT,server=y,suspend=y"
225fi
226
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100227if [ "$USE_JVM" = "y" ]; then
228 ${JAVA} ${DEBUGGER_OPTS} ${JVM_VERIFY_ARG} -classpath classes $MAIN "$@"
229 exit
230fi
231
232
233if [ "$HAVE_IMAGE" = "n" ]; then
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000234 DALVIKVM_BOOT_OPT="-Ximage:/system/non-existant/core.art"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000235else
236 DALVIKVM_BOOT_OPT="-Ximage:${BOOT_IMAGE}"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100237fi
238
239
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100240if [ "$USE_GDB" = "y" ]; then
241 if [ "$HOST" = "n" ]; then
242 GDB="$GDB_SERVER :5039"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100243 else
244 if [ `uname` = "Darwin" ]; then
245 GDB=lldb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700246 GDB_ARGS="$GDB_ARGS -- $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100247 DALVIKVM=
248 else
249 GDB=gdb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700250 GDB_ARGS="$GDB_ARGS --args $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100251 # Enable for Emacs "M-x gdb" support. TODO: allow extra gdb arguments on command line.
252 # gdbargs="--annotate=3 $gdbargs"
253 fi
254 fi
255fi
256
257if [ "$INTERPRETER" = "y" ]; then
258 INT_OPTS="-Xint"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700259 if [ "$VERIFY" = "y" ] ; then
260 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=interpret-only"
261 else
262 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
263 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
264 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100265fi
266
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800267if [ "$JIT" = "y" ]; then
Sebastien Hertz155bef42015-03-09 14:57:48 +0100268 INT_OPTS="-Xusejit:true"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800269 if [ "$VERIFY" = "y" ] ; then
Mathieu Chartiere86deef2015-03-19 13:43:37 -0700270 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-at-runtime"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800271 else
272 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
273 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
274 fi
275fi
276
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100277JNI_OPTS="-Xjnigreflimit:512 -Xcheck:jni"
278
279if [ "$RELOCATE" = "y" ]; then
280 COMPILE_FLAGS="${COMPILE_FLAGS} --include-patch-information --runtime-arg -Xnorelocate"
281 FLAGS="${FLAGS} -Xrelocate -Xcompiler-option --include-patch-information"
282 if [ "$HOST" = "y" ]; then
283 # Run test sets a fairly draconian ulimit that we will likely blow right over
284 # since we are relocating. Get the total size of the /system/framework directory
285 # in 512 byte blocks and set it as the ulimit. This should be more than enough
286 # room.
287 if [ ! `uname` = "Darwin" ]; then # TODO: Darwin doesn't support "du -B..."
288 ulimit -S $(du -c -B512 ${ANDROID_HOST_OUT}/framework | tail -1 | cut -f1) || exit 1
289 fi
290 fi
291else
292 FLAGS="$FLAGS -Xnorelocate"
293 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xnorelocate"
294fi
295
296if [ "$HOST" = "n" ]; then
297 ISA=$(adb shell ls -F /data/dalvik-cache | grep -Ewo "${ARCHITECTURES_PATTERN}")
298 if [ x"$ISA" = "x" ]; then
299 echo "Unable to determine architecture"
300 exit 1
301 fi
302fi
303
304dex2oat_cmdline="true"
305mkdir_cmdline="mkdir -p ${DEX_LOCATION}/dalvik-cache/$ISA"
306
307if [ "$PREBUILD" = "y" ]; then
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000308 dex2oat_cmdline="$INVOKE_WITH $ANDROID_ROOT/bin/dex2oatd \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100309 $COMPILE_FLAGS \
Nicolas Geoffray68e25eb2014-10-29 23:02:11 +0000310 --boot-image=${BOOT_IMAGE} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100311 --dex-file=$DEX_LOCATION/$TEST_NAME.jar \
312 --oat-file=$DEX_LOCATION/dalvik-cache/$ISA/$(echo $DEX_LOCATION/$TEST_NAME.jar/classes.dex | cut -d/ -f 2- | sed "s:/:@:g") \
313 --instruction-set=$ISA"
314fi
315
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000316dalvikvm_cmdline="$INVOKE_WITH $GDB $ANDROID_ROOT/bin/$DALVIKVM \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100317 $GDB_ARGS \
318 $FLAGS \
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700319 $DEX_VERIFY \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100320 -XXlib:$LIB \
321 $PATCHOAT \
322 $DEX2OAT \
323 $ZYGOTE \
324 $JNI_OPTS \
325 $INT_OPTS \
326 $DEBUGGER_OPTS \
327 $DALVIKVM_BOOT_OPT \
Jeff Hao207a37d2014-10-29 17:24:25 -0700328 -cp $DEX_LOCATION/$TEST_NAME.jar$SECONDARY_DEX $MAIN"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100329
Andreas Gampe3ad5d5e2015-02-03 18:26:55 -0800330# Remove whitespace.
331dex2oat_cmdline=$(echo $dex2oat_cmdline)
332dalvikvm_cmdline=$(echo $dalvikvm_cmdline)
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100333
334if [ "$HOST" = "n" ]; then
335 adb root > /dev/null
336 adb wait-for-device
337 if [ "$QUIET" = "n" ]; then
338 adb shell rm -r $DEX_LOCATION
339 adb shell mkdir -p $DEX_LOCATION
340 adb push $TEST_NAME.jar $DEX_LOCATION
341 adb push $TEST_NAME-ex.jar $DEX_LOCATION
342 else
343 adb shell rm -r $DEX_LOCATION >/dev/null 2>&1
344 adb shell mkdir -p $DEX_LOCATION >/dev/null 2>&1
345 adb push $TEST_NAME.jar $DEX_LOCATION >/dev/null 2>&1
346 adb push $TEST_NAME-ex.jar $DEX_LOCATION >/dev/null 2>&1
347 fi
348
Nicolas Geoffrayeb441dd2014-10-31 15:34:50 +0000349 LD_LIBRARY_PATH=
350 if [ "$ANDROID_ROOT" != "/system" ]; then
351 # Current default installation is dalvikvm 64bits and dex2oat 32bits,
352 # so we can only use LD_LIBRARY_PATH when testing on a local
353 # installation.
354 LD_LIBRARY_PATH=$ANDROID_ROOT/$LIBRARY_DIRECTORY
355 fi
356
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100357 # Create a script with the command. The command can get longer than the longest
358 # allowed adb command and there is no way to get the exit status from a adb shell
359 # command.
360 cmdline="cd $DEX_LOCATION && \
361 export ANDROID_DATA=$DEX_LOCATION && \
362 export DEX_LOCATION=$DEX_LOCATION && \
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000363 export ANDROID_ROOT=$ANDROID_ROOT && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100364 $mkdir_cmdline && \
Sebastien Hertz7cde48c2015-01-20 16:06:43 +0100365 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100366 $dex2oat_cmdline && \
367 $dalvikvm_cmdline"
368
369 cmdfile=$(tempfile -p "cmd-" -s "-$TEST_NAME")
370 echo "$cmdline" > $cmdfile
371
372 if [ "$DEV_MODE" = "y" ]; then
373 echo $cmdline
374 fi
375
376 if [ "$QUIET" = "n" ]; then
377 adb push $cmdfile $DEX_LOCATION/cmdline.sh
378 else
379 adb push $cmdfile $DEX_LOCATION/cmdline.sh > /dev/null 2>&1
380 fi
381
382 adb shell sh $DEX_LOCATION/cmdline.sh
383
384 rm -f $cmdfile
385else
386 export ANDROID_PRINTF_LOG=brief
Andreas Gampea8780822015-03-13 19:51:09 -0700387
388 # By default, and for prebuild dex2oat, we are interested in errors being logged. In dev mode
389 # we want debug messages.
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100390 if [ "$DEV_MODE" = "y" ]; then
391 export ANDROID_LOG_TAGS='*:d'
392 else
Andreas Gampee4301ff2015-02-17 19:25:29 -0800393 export ANDROID_LOG_TAGS='*:e'
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100394 fi
Andreas Gampea8780822015-03-13 19:51:09 -0700395
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100396 export ANDROID_DATA="$DEX_LOCATION"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000397 export ANDROID_ROOT="${ANDROID_ROOT}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100398 export LD_LIBRARY_PATH="${ANDROID_ROOT}/lib"
399 export DYLD_LIBRARY_PATH="${ANDROID_ROOT}/lib"
400 export PATH="$PATH:${ANDROID_ROOT}/bin"
401
402 cmdline="$dalvikvm_cmdline"
403
404 if [ "$TIME_OUT" = "y" ]; then
405 # Add timeout command if time out is desired.
Andreas Gampe038bb222015-01-13 19:48:14 -0800406 #
407 # Note: We use nested timeouts. The inner timeout sends SIGRTMIN+2 (usually 36) to ART, which
408 # will induce a full thread dump before abort. However, dumping threads might deadlock,
409 # so the outer timeout sends the regular SIGTERM after an additional minute to ensure
410 # termination (without dumping all threads).
411 TIME_PLUS_ONE=$(($TIME_OUT_VALUE + 1))
412 cmdline="timeout ${TIME_PLUS_ONE}m timeout -s SIGRTMIN+2 ${TIME_OUT_VALUE}m $cmdline"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100413 fi
414
415 if [ "$DEV_MODE" = "y" ]; then
416 if [ "$PREBUILD" = "y" ]; then
417 echo "$mkdir_cmdline && $dex2oat_cmdline && $cmdline"
418 elif [ "$RELOCATE" = "y" ]; then
419 echo "$mkdir_cmdline && $cmdline"
420 else
421 echo $cmdline
422 fi
423 fi
424
425 cd $ANDROID_BUILD_TOP
426
427 $mkdir_cmdline || exit 1
Andreas Gampea8780822015-03-13 19:51:09 -0700428 $dex2oat_cmdline || { echo "Dex2oat failed." >&2 ; exit 2; }
429
430 # For running, we must turn off logging when dex2oat or patchoat are missing. Otherwise we use
431 # the same defaults as for prebuilt: everything when --dev, otherwise errors and above only.
432 if [ "$DEV_MODE" = "y" ]; then
433 export ANDROID_LOG_TAGS='*:d'
434 elif [ "$USE_DEX2OAT_AND_PATCHOAT" = "n" ]; then
435 # All tests would log the error of failing dex2oat/patchoat. Be silent here and only
436 # log fatal events.
437 export ANDROID_LOG_TAGS='*:s'
438 else
439 # We are interested in LOG(ERROR) output.
440 export ANDROID_LOG_TAGS='*:e'
441 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100442
443 if [ "$USE_GDB" = "y" ]; then
444 # When running under gdb, we cannot do piping and grepping...
Dmitriy Ivanovf57874d2014-10-07 13:43:23 -0700445 $cmdline "$@"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100446 else
Dmitriy Ivanovf57874d2014-10-07 13:43:23 -0700447 $cmdline "$@" 2>&1
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100448 # Add extra detail if time out is enabled.
449 if [ ${PIPESTATUS[0]} = 124 ] && [ "$TIME_OUT" = "y" ]; then
450 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
451 fi
452 fi
453fi